unit conv_coul;

interface
USES
  Windows,
  graphics,
  sysUtils,
  GR32,
  Math;        // MaxValue,MinValue

Var
  Enbpixels:Array of integer; // pour transfert de donnes avec representepoints

  PROCEDURE RGBToHSV (CONST R,G,B:  double; VAR H,S,V:  double);
  PROCEDURE  HSVtoRGB (CONST H,S,V:double; VAR R,G,B:Double);
  PROCEDURE HLStoRGB(CONST H,L,S:  double; VAR R,G,B:  double);
  PROCEDURE RGBToHLS(CONST R,G,B:  double; VAR H,L,S:  double);

  procedure AppliqueFiltreMatrice(filtre:array of integer;dimfiltre,decal:integer;coeff:double;var Bitmap:TBitMap);
  procedure AppliqueFiltreSobel(var Bitmap:TBitMap);
  function CompareBitmap(bitmap1,bitmap2:Tbitmap):integer;

  procedure recherche_centres(BitmapSrc,BitmapCod:TBitmap32;elimineloigne:boolean;codage:integer;seuilsigma,seuilsat:double;var nombre:integer;var dmax: array of double;
     {var dmoy:array of double;var sigma:array of double;}var centres:array of Tcolor;var couleursRep:Array of Tcolor);
//  procedure etendcod(BitmapSrc,BitmapCode:TBitmap;nombre:integer;delta:double;centres:array of Tcolor;couleursRep:Array of Tcolor;codage:integer);
//  procedure representepoints(BitmapSrc,Bitmaptp:TBitmap;nombre:integer;dmax: array of double;centres:array of Tcolor;couleursRep:Array of Tcolor;mode:boolean;codage:integer;var nbpixels:array of integer);
  procedure etendcod(nombre:integer;delta,seuilsat:double;centres:array of Tcolor;couleursRep:Array of Tcolor;codage:integer;var BitmapSrc,BitmapCod:TBitmap32);
  procedure representepoints(nombre:integer;colorF:TColor32;dmax: array of double;centres:array of Tcolor;
          couleursRep:Array of Tcolor;mode:boolean;codage:integer;seuilsat:double;var BitmapSrc,Bitmaptp:TBitmap32);
  function DistCouleurs(couleur1,couleur2:Tcolor;var d2:double):double;
  function DistHVS(couleur1,couleur2:Tcolor;seuilsat:double;codage:integer;var d2:double):double;
  function DistAng(couleur1,couleur2:Tcolor;var d2:double):double;
  function DistSSp(couleur1,couleur2:Tcolor;var d2:double):double;
implementation
// Based on C Code in "Computer Graphics -- Principles and Practice,"
// Foley et al, 1996, p. 593.
//
// H = 0 to 360 (corresponding to 0..360 degrees around hexcone)
// H=-1 (undefined) for S = 0
// S = 0.0 (shade of gray) to 1 (pure color)
// V = 0.0 (black) to 1.0 (white)
  PROCEDURE RGBToHSV (CONST R,G,B:  double; VAR H,S,V:  double);
    VAR
      Delta:  double;
      Min  :  double;
  BEGIN
    Min := MinValue( [R, G, B] );
    V   := MaxValue( [R, G, B] );

    Delta := V - Min;

    // Calculate saturation:  saturation is 0 if r, g and b are all 0
    IF   V =  0.0
    THEN S := 0
    ELSE S := Delta / V;

    IF   S  = 0.0
    THEN H := -1 // Achromatic:  When s = 0, h is undefined
    ELSE BEGIN    // Chromatic
      IF   R = V
      THEN  // between yellow and magenta [degrees]
            H := 60.0 * (G - B) / Delta
      ELSE
        IF   G = V
        THEN // between cyan and yellow
             H := 120.0 + 60.0 * (B - R) / Delta
        ELSE
          IF  B = V
          THEN // between magenta and cyan
               H := 240.0 + 60.0 * (R - G) / Delta;

      IF   H < 0.0
      THEN H := H + 360.0
    END
  END {RGBtoHSV};


  // == HSV / RGB =======================================================
  //
  // Based on C Code in "Computer Graphics -- Principles and Practice,"
  // Foley et al, 1996, p. 593.
  //
  //  H = 0.0 to 360.0 (corresponding to 0..360 degrees around hexcone)
  //      H=-1 (undefined) for S = 0
  //  S = 0.0 (shade of gray) to 1.0 (pure color)
  //  V = 0.0 (black)         to 1.0 (white)

  PROCEDURE  HSVtoRGB (CONST H,S,V:double; VAR R,G,B:Double);
    VAR
      f    :  Double;
      i    :  INTEGER;
      hTemp:  Double;              // since H is CONST parameter
      p,q,t:  Double;
  BEGIN
    IF   S = 0.0                  // color is on black-and-white center line
    THEN BEGIN
        R := V;                   // achromatic:  shades of gray
        G := V;
        B := V
    END

    ELSE BEGIN                    // chromatic color
      IF   H = 360.0              // 360 degrees same as 0 degrees
      THEN hTemp := 0.0
      ELSE hTemp := H;

      hTemp := hTemp / 60;        // h is now IN [0,6)
      i := TRUNC(hTemp);          // largest integer <= h
      f := hTemp - i;             // fractional part of h

      p := V * (1.0 - S);
      q := V * (1.0 - (S * f));
      t := V * (1.0 - (S * (1.0 - f)));

      CASE i OF
        0:  BEGIN R := V;  G := t;  B := p  END;
        1:  BEGIN R := q;  G := V;  B := p  END;
        2:  BEGIN R := p;  G := V;  B := t  END;
        3:  BEGIN R := p;  G := q;  B := V  END;
        4:  BEGIN R := t;  G := p;  B := V  END;
        5:  BEGIN R := V;  G := p;  B := q  END
      END
    END
  END {HSVtoRGB};

  // == HLS / RGB =======================================================
  //
  // Based on C Code in "Computer Graphics -- Principles and Practice,"
  // Foley et al, 1996, p. 596.

  PROCEDURE HLStoRGB(CONST H,L,S:  Double; VAR R,G,B:  Double);
    VAR
      m1:  Double;
      m2:  Double;

    FUNCTION Value(CONST n1,n2:  Double;  hue:  Double):  Double;
    BEGIN
      IF   hue > 360.0
      THEN hue := hue - 360.0
      ELSE
        IF   hue < 0.0
        THEN hue := hue + 360.0;

      IF   hue < 60.0
      THEN RESULT := n1 + (n2 - n1)*hue / 60.0
      ELSE
        IF   hue < 180
        THEN RESULT := n2
        ELSE
          IF   hue < 240.0
          THEN RESULT := n1 + (n2-n1)*(240.0 - hue) / 60.0
          ELSE RESULT := n1
    END {Value};

  BEGIN
    IF   L <= 0.5
    THEN m2 := L * (L + S)
    ELSE m2 := L + S - L*S;
    m1 := 2.0 * L - m2;

    IF   S = 0.0
    THEN BEGIN      // achromatic -- no hue
      {IF   H=-1
      THEN BEGIN}
        R := L;
        G := L;
        B := L
      {END
      ELSE RAISE EColorError.Create('HLStoRGB:  S = 0 and H has a value');}
    END
    ELSE BEGIN
      // Chromatic case -- there is a hue
      R := Value(m1, m2, H + 120.0);
      G := Value(m1, m2, H);
      B := Value(m1, m2, H - 120.0)
    END
  END {HLStoRGB};


  // H = 0 to 360 (corresponding to 0..360 degrees around hexcone)
  // L = 0.0 (shade of gray) to 1.0 (pure color)
  // S = 0.0 (black)         to 1.0 {white)
  //
  // R, G, B each in [0,1]
  //
  // Based on C Code in "Computer Graphics -- Principles and Practice,"
  // Foley et al, 1996, p. 595.

PROCEDURE RGBToHLS (CONST R,G,B:  Double; VAR   H,L,S:  Double);
VAR
      Delta:  Double;
      Max  :  Double;
      Min  :  Double;
BEGIN
    Max := MaxValue( [R, G, B] );
    Min := MinValue( [R, G, B] );

    L := (Max + Min) / 2.0;   // Lightness

    IF   Max = Min            // Achromatic case since r = g = b
    THEN BEGIN
      S := 0.0;
      H := -1;               // Undefined
    END
    ELSE BEGIN
      Delta := Max - Min;

      IF   L <= 0.5
      THEN S := Delta / (Max + Min)
      ELSE S := Delta / (2.0 - (Max + Min));

      IF   R = Max
      THEN // degrees between yellow and magenta
           H := (60.0*(G - B)) / Delta
      ELSE
        IF   G = Max
        THEN // degrees between cyan and yellow
             H := 120.0 + (60.0*(B - R)) / Delta
        ELSE
          IF  B = Max
          THEN // degrees between magenta and cyan
               H := 240.0 + (60.0*(R - G)) / Delta;

      IF   H < 0
      THEN H := H + 360.0;  // Keep in interval [0, 360]

    END
END {RGBtoHLS};

procedure AppliqueFiltreMatrice(filtre:array of integer;dimfiltre,decal:integer;coeff:double;var Bitmap:TBitMap);
var
  Scanlinesource:Array[-3..3] of PByteArray;
  Scanlinedest:PByteArray;
  Bitmaptemp:TBitmap;
  i,j,k,x,y,w,h,n,dimmat:integer;
  ip,jp:word;
  val:longint;
begin
  dimmat:=2*dimfiltre+1;
  for i:=-3 to 3 do Scanlinesource[i]:=nil;
  BitmapTemp:=TBitMap.create;
  try
    w:=Bitmap.Width;
    BitmapTemp.width:=w;
    h:=Bitmap.Height;
    BitmapTemp.Height:=h;
    Bitmap.PixelFormat:=pf24bit;
    BitmapTemp.Canvas.Draw(0,0,Bitmap);
    BitmapTemp.PixelFormat:=pf24bit;
    for Y:=0 to h-1 do
      begin
        for i:=-dimfiltre to dimfiltre do
          if ((Y+i)>=0) and ((Y+i)<h) then Scanlinesource[i]:=Bitmap.ScanLine[y+i];
        Scanlinedest:=BitmapTemp.ScanLine[y];
        for x:=0 to w-1 do
          begin
            for k:=0 to 2 do
              begin
                val:=0;
                n:=0;
                for j:=-dimfiltre to dimfiltre do if ((y+j)>0) and ((y+j)<h) then
                  for i:=-dimfiltre to dimfiltre do
                    begin
                      ip:=i+dimfiltre;
                      jp:=j+dimfiltre;
                      if ((x+i)>0) and ((x+i)<w) then
                        begin
                          val:=val+Scanlinesource[j,(x+i)*3+k]*filtre[ip+jp*dimmat];
                          n:=n+filtre[ip+jp*dimmat];
                        end;
                    end;
                val:=round(val/n*coeff)+decal;
                if val<0 then val:=0;
                if val>255 then val:=255;
                Scanlinedest[x*3+k]:=val;
              end;
          end;
      end;
    Bitmap.Assign(BitmapTemp);
  finally
    BitmapTemp.free;
  end;
end;
// Filtre Sobel
procedure AppliqueFiltreSobel(var Bitmap:TBitMap);
var
  Scanlinesource:Array[-1..1] of PByteArray;
  Scanlinedest:PByteArray;
  Bitmaptemp:TBitmap;
  i,j,k,x,y,w,h,v:integer;
  val1,val2:longint;
  valfiltre:array[0..255,0..255] of integer;
  filtre1:array[-1..1,-1..1] of integer;
  filtre2:array[-1..1,-1..1] of integer;
begin
  for i:=-1 to 1 do Scanlinesource[i]:=nil;
  for i:=0 to 255 do
    for j:=0 to 255 do
      begin
        v:=round(sqrt(i*i+j*j));
        valfiltre[i,j]:=Min(v,255);
      end;
  filtre1[-1,-1]:=-1;
  filtre1[-1,0]:=-2;
  filtre1[-1,1]:=-1;
  filtre1[0,-1]:=0;
  filtre1[0,0]:=0;
  filtre1[0,1]:=0;
  filtre1[1,-1]:=1;
  filtre1[1,0]:=2;
  filtre1[1,1]:=1;

  filtre2[-1,-1]:=-1;
  filtre2[0,-1]:=-2;
  filtre2[1,-1]:=-1;
  filtre2[-1,0]:=0;
  filtre2[0,0]:=0;
  filtre2[1,0]:=0;
  filtre2[-1,1]:=1;
  filtre2[0,1]:=2;
  filtre2[1,1]:=1;
  BitmapTemp:=TBitMap.create;
  try
    w:=Bitmap.Width;
    BitmapTemp.width:=w;
    h:=Bitmap.Height;
    BitmapTemp.Height:=h;
    Bitmap.PixelFormat:=pf24bit;
    BitmapTemp.Canvas.Draw(0,0,Bitmap);
    BitmapTemp.PixelFormat:=pf24bit;
    for Y:=1 to h-2 do
      begin
        for i:=-1 to 1 do Scanlinesource[i]:=Bitmap.ScanLine[y+i];
        Scanlinedest:=BitmapTemp.ScanLine[y];
        for x:=1 to w-2 do
          begin
            for k:=0 to 2 do
              begin
                val1:=0;
                val2:=0;
                for j:=-1 to 1 do
                  for i:=-1 to 1 do
                    begin
                      val1:=val1+Scanlinesource[j,(x+i)*3+k]*filtre1[i,j];
                      val2:=val2+Scanlinesource[j,(x+i)*3+k]*filtre2[i,j];
                    end;
                if val1<0 then val1:=0;
                if val1>255 then val1:=255;
                if val2<0 then val2:=0;
                if val2>255 then val2:=255;
                Scanlinedest[x*3+k]:=valfiltre[val1,val2];
              end;
          end;
      end;
    Bitmap.Assign(BitmapTemp);
  finally
    BitmapTemp.free;
  end;
end;
// compareBitmap
function CompareBitmap(bitmap1,bitmap2:Tbitmap):integer; //nombre de diffrences ou -1 si dim diffrentes
var
  ScanLine1 : PByteArray;
  ScanLine2 : PByteArray;
  x,y,c,w,h:integer;
  different:boolean;
begin
  w:=Bitmap1.width;
  h:=Bitmap1.height;
  if (Bitmap2.width<>w) or (Bitmap2.height<>h) or (Bitmap1=nil) or (Bitmap2=nil) then
    begin
      result:=-1;
    end
  else
    begin
      BitMap1.PixelFormat := pf24bit;
      BitMap2.PixelFormat := pf24bit;
      result:=0;
      for y:=0 to h-1 do
        begin
          scanline1:=Bitmap1.scanline[y];
          scanline2:=Bitmap2.scanline[y];
          for x:=0 to w-1 do
            begin
              different:=false;
              for c:=0 to 3 do if (ScanLine1[x*3+c]<>ScanLine2[x*3+c]) then different:=true;
              if different then inc(result);
            end;
        end;
    end;
end;
function CompareBitmap32(bitmap1,bitmap2:Tbitmap32):integer; //nombre de diffrences ou -1 si dim diffrentes
var
  x,y,c,w,h:integer;
  different:boolean;
begin
  w:=Bitmap1.width;
  h:=Bitmap1.height;
  if (Bitmap2.width<>w) or (Bitmap2.height<>h) or (Bitmap1=nil) or (Bitmap2=nil) then
    begin
      result:=-1;
    end
  else
    begin
      result:=0;
      for y:=0 to h-1 do for x:=0 to w-1 do
        if Bitmap2[x,y]<>Bitmap1[x,y] then inc(result);
    end;
end;
//recherche_centres
procedure recherche_centres(BitmapSrc,BitmapCod:TBitmap32;elimineloigne:boolean;codage:integer;seuilsigma,seuilsat:double;var nombre:integer;var dmax: array of double;
    {var dmoy:array of double;var sigma:array of double;var coeffi:array of double;}var centres:array of Tcolor;var couleursRep:Array of Tcolor);
var
  x,y,c,i,w,h,numc:integer;
  dist,dist2:double;
  couleurCod:Tcolor;
  couleurimg:Tcolor32;
  coultemp:Tcolor32;
  totaux:Array [0..50,0..2] of integer;
  nombp:Array [0..50] of integer;
  totdist:Array [0..50] of double;
  totdist2:Array [0..50] of double;
  dmoy:array [0..50] of double;
  sigma:array [0..50] of double;
  xi,xi2:array [0..50,0..2] of double;
begin
  w:=BitmapSrc.width;
  h:=BitmapSrc.height;
  if (BitmapCod.width<>w) or (BitmapCod.height<>h) or (BitmapSrc=nil) or (BitmapCod=nil) then
    begin
      nombre:=-1;
    end
  else
    begin
      nombre:=0;
      for i:=0 to 50 do
        begin
          nombp[i]:=0;
          dmax[i]:=0;
          totdist[i]:=0;
          totdist2[i]:=0;
          for c:=0 to 2 do
            begin
              totaux[i,c]:=0;
            end;
        end;
      // premier scan pour rechercher les couleurs, leur nombre et les centres de gravit;
      for y:=0 to h-1 do
        begin
          for x:=0 to w-1 do
            begin
              coultemp:=BitmapCod[x,y];
              if AlphaComponent(Coultemp)>0 then
                begin
                  couleurCod:=Wincolor(Coultemp);
                  numc:=-1;
                  for i:=0 to nombre-1 do
                    begin
                      if Wincolor(coultemp)=couleursRep[i] then
                        begin
                          numc:=i;
                          break;
                        end;
                    end;
                  if numc=-1 then
                    begin
                      couleursRep[nombre]:=Wincolor(coultemp);
                      numc:=nombre;
                      inc(nombre);
                    end;
                  inc(nombp[numc]);
                  couleurimg:=BitmapSrc[x,y];
                  totaux[numc,0]:=totaux[numc,0]+BlueComponent(couleurimg);
                  totaux[numc,1]:=totaux[numc,1]+GreenComponent(couleurimg);
                  totaux[numc,2]:=totaux[numc,2]+RedComponent(couleurimg);
                end;
            end;
        end;
      for i:=0 to nombre-1 do
        begin
          centres[i]:=RGB(Round(totaux[i,2]/nombp[i]),Round(totaux[i,1]/nombp[i]),Round(totaux[i,0]/nombp[i]));
        end;
      //si nombre>0, refaire un scan pour dterminer les distances maximales et ecarts types
      if nombre<1 then exit;
      for y:=0 to h-1 do
        begin
          for x:=0 to w-1 do
            begin
              coultemp:=BitmapCod[x,y];
              if AlphaComponent(Coultemp)>0 then
                begin
                  couleurCod:=Wincolor(Coultemp);
                  numc:=-1;
                  for i:=0 to nombre-1 do
                    begin
                      if couleurCod=couleursRep[i] then
                        begin
                          numc:=i;
                          break;
                        end;
                    end;
                  if (numc>-1) and (numc<nombre) then
                    begin
                      //couleurCod:=RGB(scanlineSrc[3*x+2],scanlineSrc[3*x+1],scanlineSrc[3*x]);
                      CouleurCod:=WinColor(BitmapSrc[x,y]);
                      case codage of
                        0:dist:=DistCouleurs(couleurCod,centres[numc],dist2);
                        1,2:dist:=DistHVS(couleurCod,centres[numc],seuilsat,codage,dist2);
                        3:dist:=DistAng(couleurCod,centres[numc],dist2);
                        4:dist:=DistSSp(couleurCod,centres[numc],dist2);
                      end;
                      dmax[numc]:=Max(dist,dmax[numc]);
                      totdist[numc]:=totdist[numc]+dist;
                      totdist2[numc]:=totdist2[numc]+dist2;
                    end;
                end;
            end;
        end;
      for i:=0 to nombre-1 do
        begin
          dmoy[i]:=totdist[i]/nombp[i];
          sigma[i]:=sqrt(totdist2[i]/nombp[i]-dmoy[i]*dmoy[i]);
          dmax[i]:=Min(dmax[i],dmoy[i]+seuilsigma*sigma[i]);
        end;
    end;
end;

//BitmapSrc: image sur laquelle on travaille
//nombre:nombre de catgories
//dmax:distance maximale d'un point d'un groupe au centre de gravit du groupe
//centres:couleurs des centres de gravits respectifs des nombre nuages de points dans l'espace des couleurs
//couleursRep:les nombre couleurs utilises comme repres
//la fonction renvoie une nouvelle image contenant les zones dlimites
procedure representepoints(nombre:integer;colorF:TColor32;dmax: array of double;centres:array of Tcolor;
          couleursRep:Array of Tcolor;mode:boolean;codage:integer;seuilsat:double;var BitmapSrc,Bitmaptp:TBitmap32);
var
  x,y,i,w,h:integer;
  couleur:Tcolor;
  indice:integer;
  distance,dist2:double;
  distancemin:double;
begin
  SetLength(EnbPixels,nombre);
  w:=BitmapSrc.width;
  h:=BitmapSrc.height;
  Bitmaptp.SetSize(w,h);
  for i:=0 to nombre-1 do Enbpixels[i]:=0;   //Enbpixels : tableau de conv_coul
  for y:=0 to h-1 do
        begin
          for x:=0 to w-1 do
            begin
              couleur:=Wincolor(BitmapSrc[x,y]);
              indice:=-1;
              distanceMin:=450.0;
              for i:=0 to nombre-1 do
                begin
                  case codage of
                    0:distance:=DistCouleurs(couleur,centres[i],dist2);
                    1,2:distance:=DistHVS(couleur,centres[i],seuilsat,codage,dist2);
                    3:distance:=DistAng(couleur,centres[i],dist2);
                    else distance:= DistSSp(couleur,centres[i],dist2);
                  end;

                  if (distance<=dmax[i]) and (distance<distanceMin) then
                    begin
                      indice:=i;
                      distanceMin:=distance;
                    end;
                end;
              if indice>-1 then
                begin
                  Enbpixels[indice]:=Enbpixels[indice]+1;
                  if mode then Bitmaptp[x,y]:=Color32(centres[indice])
                  else Bitmaptp[x,y]:=Color32(couleursRep[indice]);
                end
              else Bitmaptp[x,y]:=ColorF;
            end;
        end;
end;

//BitmapSrc: image sur laquelle on travaille
//BitmapCode: image contenant les zones dlimites
//nombre:nombre de catgories
//delta:plus petit ecart de distance admissible (critre non oprant si =0)
//centres:couleurs des centres de gravits respectifs des nombre nuages de points dans l'espace des couleurs
//couleursRep:les nombre couleurs utilises comme repres
procedure etendcod(nombre:integer;delta,seuilsat:double;centres:array of Tcolor;couleursRep:Array of Tcolor;codage:integer;var BitmapSrc,BitmapCod:TBitmap32);
var
  x,y,c,i,w,h:integer;
  couleur:Tcolor;
  indice:integer;
  distance,dist2:double;
  //couleurCod:array [0..2] of word;
  distancemin:double;
begin
  w:=BitmapSrc.width;
  h:=BitmapSrc.height;
  for y:=0 to h-1 do
        begin
          for x:=0 to w-1 do
            begin
              couleur:=Wincolor(BitmapSrc[x,y]);
              indice:=-1;
              distanceMin:=450.0;
              for i:=0 to nombre-1 do
                begin
                  case codage of
                    0:distance:=DistCouleurs(couleur,centres[i],dist2);
                    1,2:distance:=DistHVS(couleur,centres[i],seuilsat,codage,dist2);
                    3:distance:=DistAng(couleur,centres[i],dist2)
                    else distance:= DistSSp(couleur,centres[i],dist2);
                  end;
                  if (distance<distanceMin) then
                    begin
                      if (distanceMin-distance)> delta then
                        begin
                         distanceMin:=distance;
                         indice:=i;
                        end
                      else indice:=-1;
                    end;
                end;
              if indice>-1 then
                begin
                  //couleurCod[2]:=GetRValue(couleursRep[indice]);
                  //couleurCod[1]:=GetGValue(couleursRep[indice]);
                  //couleurCod[0]:=GetBValue(couleursRep[indice]);
                  //BitmapCod[x,y]:=Color32(couleurCod[2],couleurCod[1],couleurCod[0]);
                  BitmapCod[x,y]:=Color32(couleursRep[indice]);
                end
              else BitmapCod[x,y]:=$00000000;
            end;
        end;
end;
function DistCouleurs(couleur1,couleur2:Tcolor;var d2:double):double;
var
  R1,G1,B1,R2,G2,B2:integer;
  //d2:double;
begin
  R1:=GetRValue(couleur1);
  G1:=GetGValue(couleur1);
  B1:=GetBValue(couleur1);
  R2:=GetRValue(couleur2);
  G2:=GetGValue(couleur2);
  B2:=GetBValue(couleur2);
  d2:=(R1-R2)*(R1-R2)+(G1-G2)*(G1-G2)+(B1-B2)*(B1-B2);
  result:=sqrt(d2);
end;

function DistHVS(couleur1,couleur2:Tcolor;seuilsat:double;codage:integer;var d2:double):double;
var
  R1,G1,B1,R2,G2,B2:double;
  H1,S1,V1,H2,S2,V2:double;
  a:double;
  //seuilsat:double;
begin
  seuilsat:=0.1;
  R1:=GetRValue(couleur1)/255;
  G1:=GetGValue(couleur1)/255;
  B1:=GetBValue(couleur1)/255;
  if codage=1 then RGBToHSV (R1,G1,B1, H1,S1,V1) else RGBToHLS (R1,G1,B1, H1,V1,S1);

  R2:=GetRValue(couleur2)/255;
  G2:=GetGValue(couleur2)/255;
  B2:=GetBValue(couleur2)/255;
  if codage=1 then  RGBToHSV (R2,G2,B2, H2,S2,V2) else RGBToHLS (R2,G2,B2, H2,V2,S2);
  a:=abs(H2-H1);
  if a>180 then a:=360-a;
  if (S1<seuilsat) and (S2<seuilsat) then  a:=0
  else if (S1<seuilsat) or (S2<seuilsat) then  a:=a/2;
  d2:=a*a+14400*(V1-V2)*(V1-V2)+14400*(S1-S2)*(S1-S2);
  result:=sqrt(d2);
end;
function DistAng(couleur1,couleur2:Tcolor;var d2:double):double;
var
  R1,G1,B1,R2,G2,B2:integer;
  S1,S2:double;
  V:double;
  cosa,a:double;
begin
  R1:=GetRValue(couleur1);
  G1:=GetGValue(couleur1);
  B1:=GetBValue(couleur1);
  R2:=GetRValue(couleur2);
  G2:=GetGValue(couleur2);
  B2:=GetBValue(couleur2);
  S1:=sqrt(R1*R1+G1*G1+B1*B1);
  S2:=sqrt(R2*R2+G2*G2+B2*B2);
  cosa:=((R1*R2)+(G1*G2)+(B1*B2))/(S1*S2);
  a:=ArcCos(cosa)/Pi*180.0;
  V:=Abs(S1-S2);
  d2:=16*a*a+V*V;
  result:=sqrt(d2);
end;
function DistSSp(couleur1,couleur2:Tcolor;var d2:double):double;
var
  R1,G1,B1,R2,G2,B2:integer;
  dRB,dRG,d:double;
begin
  R1:=GetRValue(couleur1);
  G1:=GetGValue(couleur1);
  if G1=0 then G1:=1;
  B1:=GetBValue(couleur1);
  if B1=0 then B1:=1;
  R2:=GetRValue(couleur2);
  G2:=GetGValue(couleur2);
  if G2=0 then G2:=1;
  B2:=GetBValue(couleur2);
  if B2=0 then B2:=1;
  d:=R2-R1;
  dRB:=(R1/B1)-(R2/B2);
  dRG:=(R1/G1)-(R2/G2);
  d2:=d*d+dRB*dRB+dRG*dRG;
  result:=sqrt(d2);
end;

end.
